﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Rewards2Model
{
   using System;
   using System.Data.Entity;
   using System.Data.Entity.Infrastructure;

   // Added for manual data mapping.
   using System.Data.Entity;
   using System.Data.Entity.ModelConfiguration;
   using System.ComponentModel.DataAnnotations.Schema;

   public partial class Rewards2ModelContainer : DbContext
   {
      public Rewards2ModelContainer()
         : base("name=Rewards2ConnectionString")
      {
      }

      // Create properties to access the POCO classes.
      public DbSet<Customers> Customers { get; set; }
      public DbSet<Purchases> Purchases { get; set; }

      // Perform some manual mapping of the data.
      protected override void OnModelCreating(DbModelBuilder MB)
      {
         // Load the custom configuration.
         MB.Configurations.Add(new CustomerMap());
      }
   }

   public class CustomerMap : EntityTypeConfiguration<Customers>
   {
      public CustomerMap()
      {
         // Specify the name of the table to use.
         this.ToTable("Customers");

         // Define the key for this table.
         this.HasKey(key => key.Id);

         // Specify the mapping for each of the table properties.
         this.Property(prop => prop.Id)
            .HasColumnName("Id")
            .HasColumnType("int")
            .HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity)
            .IsRequired();

         this.Property(prop => prop.CustomerName)
            .HasColumnName("Cust_Name")
            .HasColumnType("nvarchar")
            .IsRequired();

         this.Property(prop => prop.CustomerType)
            .HasColumnName("Cust_Type")
            .HasColumnType("int")
            .IsOptional();

         this.Property(prop => prop.CustomerLocation.Telephone)
            .HasColumnName("Cust_Telephone")
            .HasColumnType("nvarchar")
            .HasMaxLength(13)
            .IsOptional();

         this.Property(prop => prop.CustomerLocation.ZIPCode)
            .HasColumnName("Cust_ZIP")
            .HasColumnType("nvarchar")
            .HasMaxLength(10)
            .IsOptional();
      }
   }
}
